#pragma warning(disable: 4001)  // nameless unions are part of C++
#pragma warning(disable: 4705)  // TRACE turned into statement with no effect   

/*
 *    (C) Copyright 1994 by Autodesk, Inc.
 *
 *    This program is copyrighted by Autodesk, Inc. and is  licensed
 *    to you under the following conditions.  You may not distribute
 *    or  publish the source code of this program in any form.   You
 *    may  incorporate this code in object form in derivative  works
 *    provided  such  derivative  works  are  (i.) are  designed and
 *    intended  to  work  solely  with  Autodesk, Inc. products, and
 *    (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright
 *    1994 by Autodesk, Inc."
 *
 *    AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
 *    AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
 *    CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
 *    DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
 *    UNINTERRUPTED OR ERROR FREE.
 */

#include <windows.h>
#include "awcemail.h"                                

// added these two includes for sprintf, shellexecute
#include <stdio.h>
#include <shellapi.h>
           
// Here ShellExecute needs a HWND.
// This function merely gets a "Dummy" window handle, as AWCEMAIL.DLL has none.
// It should get the handle of either Program Manager, or WorkCenter, to use as
// the parent window for the ShellExecute process that runs SEND.EXE. It is 
// possible, however, to get a handle that is innapropriate to use... but rare.

static HWND GetDummyWindow()
{    
	HWND win;	
	win = FindWindow(NULL, "Program Manager");
	return (win == NULL ? GetTopWindow(NULL) : win);
}

// ---------------------------------------------------------------------
// DLL specific functions
// ---------------------------------------------------------------------

int FAR PASCAL LibMain(HANDLE hInstance, WORD wDataSeg,
                          WORD cbHeapSize, LPSTR lpCmdLine)
{
	// take care of compiler warnings
	lpCmdLine = lpCmdLine;
	wDataSeg = wDataSeg;  
	hInstance = hInstance;

	if ( 0 != cbHeapSize ) 
		UnlockData(0);
		
	return 1;
}

void AWCEMAPI AWC_EMail(LPCSTR pUserName, LPCSTR pAltUserName,
	short nType, LPCSTR pObjectId, LPCSTR pSubject, LPCSTR pMsg,
	DOCLIST hActiveDocs, DOCLIST hRefDocs )
{                 
	

	// New Stuff - declares for the SEND message functions  
    char Exefile[11];
	char CurDir[12];
	char Cmd[64];
	HWND Dummy;

	// just eliminate warnings
	pUserName = pUserName;
	pAltUserName = pAltUserName;
	nType = nType;
	pObjectId = pObjectId;
	pSubject = pSubject;
	pMsg = pMsg;
	hActiveDocs = hActiveDocs;
	hRefDocs = hRefDocs;  
	
    //New Stuff - Create strings for message, run SEND.EXE
    Dummy = GetDummyWindow();
    sprintf( Exefile, "%s", "SEND.EXE");
	sprintf( CurDir, "%s", NULL); // This wouldn't work when I tried to use a path here, 
	                              // NULL seems to force path to environment path which is fine.
	
	sprintf( Cmd, " \"%s %s\" %s", "You have a Workflow message:", pSubject, pAltUserName);

                // If Alternate user name is blank for To: user, will send message to ALL -
                // It would not be a bad Idea to add code here to cancel if AltUserName==""

		ShellExecute(Dummy, NULL, Exefile, Cmd, CurDir, 2); 

    // Initially I tried 4 for execution parameter, but it didn't work. Must use execution mode with focus.
	// This causes screen to "Flash" as shell executes, a different parameter would cause it to run minimized.
} 


