/*
 *    (C) Copyright 1994 by Autodesk, Inc.
 *
 *    This program is copyrighted by Autodesk, Inc. and is  licensed
 *    to you under the following conditions.  You may not distribute
 *    or  publish the source code of this program in any form.   You
 *    may  incorporate this code in object form in derivative  works
 *    provided  such  derivative  works  are  (i.) are  designed and
 *    intended  to  work  solely  with  Autodesk, Inc. products, and
 *    (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright
 *    1994 by Autodesk, Inc."
 *
 *    AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
 *    AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
 *    CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
 *    DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
 *    UNINTERRUPTED OR ERROR FREE.
 */
#ifndef _AWCEMAIL_H
#define _AWCEMAIL_H 

#define AWCEMAPI FAR PASCAL _export

#define DOCLIST	LPCSTR

#define EMAIL_TYPE_WORKFLOW			0
#define EMAIL_TYPE_NOTIFICATION		1
#define EMAIL_TYPE_WORKFLOWNOTIFY	2

#ifdef __cplusplus
extern "C"
{
#endif

void AWCEMAPI AWC_EMail(LPCSTR pUserName,			// Users email name string
						LPCSTR pAltUsername,		// Altrnate user name string
						short nType,				// message type (0=WF, 1=Notification)
						LPCSTR pObjectId, 			// Document ID (for notifications) or
													// Workflow ID (future use) string
						LPCSTR pSubject,			// subject text string
						LPCSTR pMsg,				// message text string
						DOCLIST pActiveDocs,		// Active documents for this message  (Only for WF)
						DOCLIST pReferenceDocs);	// Reference document for this message.  (Only for WF)

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _AWCEMAIL_H
